/*   Game w/o a name
    -===============-
    Started: March 24, 2004
    By: Erik Eriksen
    
    About: 
      In this game, the object is to collect the gold bar in each level. Grabbing
      dots will increase your points. Run from bad guys to stay safe while reaching
      for the gold. (Pun intended). 
      
 TO DO LIST:
 -----------
   - Dot collision detection code SUCKS and is super cumbersome. Think of something
     easier to save space and have it so that it works for level changes.
     
   - Score method needs to be re-thunk... well not really, but something more 
     "classy" would be nice.
       
   - Nothing about level changing even started to be coded yet.
   
   - Nothing about bad guys coded yet.
   
   - Color? better yet... SPRITES!?!?
   
   - Menu's... title screen... GAME NAME? 
*/

#include <stdio.h>
#include <conio.h>
#include <conio.c>
#include <iostream>
#include <time.h>

using namespace std;

const char upArrow = 72;
const char downArrow = 80;
const char leftArrow = 75;
const char rightArrow = 77;
const char enterButton = 13;
const int player = 1;
int areaNumber = 1;

struct inventory
{
  bool haveGold;
  int numberOfDots;
};

struct spots
{
  int dXpos;
  int dYpos;
  bool dotThere;
};

struct levelEnd
{
  int gXpos;
  int gYpos;
};
  

void drawField(int areaNumber)
{
  switch (areaNumber)
  {
    case 1:
      printf("1");
      break;
    
    case 2:
      printf("2");
      break;
    
    default:
      printf("ERROR: Invalid level # load.\n");
      break;
  } //switch end
}


int main()
{
  char keyInput = 0;
  int xPos = 5, yPos = 10, count = 0;
  int numberOfDotsInLevel = 2;
  int score = 0, secondCount = 0;
  inventory items;
  spots dots[numberOfDotsInLevel];
  levelEnd gold;
  
  srand((unsigned)time(NULL));   
  items.haveGold = false;
  items.numberOfDots = 0;
  
  //dots locations
  for (count = 0; count <= numberOfDotsInLevel; count++)
  {
    dots[count].dXpos = (rand() % 60) + 1;
    dots[count].dYpos = (rand() % 20) + 1;
    dots[count].dotThere = true;
  }
  
  //gold location
  gold.gXpos = (rand() % 60) + 1;
  gold.gYpos = (rand() % 20) + 1;
  
  system("cls");
  textcolor(7);
  drawField(areaNumber);
  
  for (count = 0; count <= numberOfDotsInLevel; count++)
  {
    gotoxy(dots[count].dXpos, dots[count].dYpos);
    printf("*");
  }
  
  gotoxy(gold.gXpos, gold.gYpos);
  textcolor(14);
  printf("=");
  textcolor(7);
  
  keyInput = kbhit();
  
  while (keyInput != 27)
  {
    gotoxy(50, 1);
    printf("Score: %d\n", score);
    
    gotoxy(1,1);
    printf("items.numberOfDots = %d\n", items.numberOfDots);
    gotoxy(1,2);
    printf("Have gold == %d\n", items.haveGold);
    
    /*Out of bounds detection*/
    
    if (xPos < 1)
      xPos = 1;
    
    else if (xPos > 60)
      xPos = 60;
      
    if (yPos < 1)
      yPos = 1;
    
    else if (yPos > 20)
      yPos = 20;

    gotoxy(xPos, yPos);
    printf("%c\n", player);
  
    keyInput = getch();
    
    switch (keyInput)
    {
      case upArrow:
        yPos -= 1;
        gotoxy(xPos, yPos + 1);
        printf(" ");
        break;
      
      case downArrow:
        yPos += 1;
        gotoxy(xPos, yPos - 1);
        printf(" ");
        break;
        
      case leftArrow:
        xPos -= 1;
        gotoxy(xPos + 1, yPos);
        printf(" ");
        break;
      
      case rightArrow:
        xPos += 1;
        gotoxy(xPos - 1, yPos);
        printf(" ");
        break;
      
      case enterButton:
        system("cls");
        printf("\n\n\n");
        for (count = 0; count <= numberOfDotsInLevel; count++)
        {
          printf("dot %d Xpos: %d\n", count + 1, dots[count].dXpos);
          printf("dot %d Ypos: %d\n", count + 1, dots[count].dYpos);
        }        
        break;
        
      default:
        continue;
    }//switch end

    //FUCK THIS OLD WAY, THINK OF SOMETHING NEW
    //DOESN'T WORK W/ LEVEL CHANGING!!    
    if (xPos == dots[0].dXpos && yPos == dots[0].dYpos && dots[0].dotThere == true)
    {  
      items.numberOfDots++;
      dots[0].dotThere = false;
      score += 100;
    }
    
    else if (xPos == dots[1].dXpos && yPos == dots[1].dYpos && dots[1].dotThere == true)
    {
      items.numberOfDots++;
      dots[1].dotThere = false;
      score += 100;
    }
    
    else if (xPos == dots[2].dXpos && yPos == dots[2].dYpos && dots[2].dotThere == true)
    { 
      items.numberOfDots++;
      dots[2].dotThere = false;      
      score += 100;
    }
    
    if (xPos == gold.gXpos && yPos == gold.gYpos  && items.haveGold == false)
    {
      items.haveGold = true;
      score += 500;
      gotoxy(1,1);
      while (secondCount < 3200)
      {
        for (count = 0; count <= 15; count++)
        {
          textcolor(count);
          printf("%c", 178);
          secondCount++;
        }
      }
      printf("Congrats, Press any key\n");
      getch(); //pause
      system("cls");
    }
  }
  
  return 0;
}
  
